## ros-rolling-robot-localization 3.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(robot_localization)
 
 if(NOT WIN32)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
@@ -15,6 +15,7 @@
 endif()
 
 find_package(ament_cmake REQUIRED)
+find_package(angles REQUIRED)
 find_package(rclcpp REQUIRED)
 find_package(diagnostic_msgs REQUIRED)
 find_package(diagnostic_updater REQUIRED)
@@ -35,7 +36,7 @@
 
 # Geographiclib installs FindGeographicLib.cmake to this non-standard location
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "/usr/share/cmake/geographiclib/")
-find_package(GeographicLib REQUIRED COMPONENTS STATIC)
+find_package(GeographicLib REQUIRED)
 
 set(library_name rl_lib)
 
@@ -104,6 +105,7 @@
 
 ament_target_dependencies(
   ${library_name}
+  angles
   diagnostic_msgs
   diagnostic_updater
   geographic_msgs
@@ -196,20 +198,30 @@
   rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
   target_link_libraries(test_ekf "${cpp_typesupport_target}")
 
-  ament_add_gtest_executable(test_ekf_localization_node_interfaces
-                    test/test_ekf_localization_node_interfaces.cpp)
-  target_link_libraries(test_ekf_localization_node_interfaces ${library_name})
-
-  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
-  target_link_libraries(test_ekf_localization_node_interfaces "${cpp_typesupport_target}")
-
-  add_dependencies(test_ekf_localization_node_interfaces ekf_node)
-  ament_add_test(test_ekf_localization_node_interfaces
+  ament_add_gtest_executable(
+    test_ekf_node_interfaces
+    test/test_se_node_interfaces.cpp)
+  target_link_libraries(
+    test_ekf_node_interfaces
+    ${library_name})
+
+  rosidl_get_typesupport_target(
+    cpp_typesupport_target
+    "${PROJECT_NAME}" "rosidl_typesupport_cpp")
+  target_link_libraries(
+    test_ekf_node_interfaces
+    "${cpp_typesupport_target}")
+
+  add_dependencies(
+    test_ekf_node_interfaces
+    ekf_node)
+  ament_add_test(
+    test_ekf_node_interfaces
     GENERATE_RESULT_FOR_RETURN_CODE_ZERO
     TIMEOUT 300
-    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ekf_localization_node_interfaces.launch.py"
-  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-  )
+    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_se_node_interfaces.launch.py"
+    ENV NODE_TYPE=ekf
+  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
 
   #### UKF TESTS #####
   ament_add_gtest(test_ukf test/test_ukf.cpp)
@@ -218,20 +230,30 @@
   rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
   target_link_libraries(test_ukf "${cpp_typesupport_target}")
 
-  ament_add_gtest_executable(test_ukf_localization_node_interfaces
-                    test/test_ukf_localization_node_interfaces.cpp)
-  target_link_libraries(test_ukf_localization_node_interfaces ${library_name})
-
-  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
-  target_link_libraries(test_ukf_localization_node_interfaces "${cpp_typesupport_target}")
-
-  add_dependencies(test_ukf_localization_node_interfaces ukf_node)
-  ament_add_test(test_ukf_localization_node_interfaces
+  ament_add_gtest_executable(
+    test_ukf_node_interfaces
+    test/test_se_node_interfaces.cpp)
+  target_link_libraries(
+    test_ukf_node_interfaces
+    ${library_name})
+
+  rosidl_get_typesupport_target(
+    cpp_typesupport_target
+    "${PROJECT_NAME}" "rosidl_typesupport_cpp")
+  target_link_libraries(
+    test_ukf_node_interfaces
+    "${cpp_typesupport_target}")
+
+  add_dependencies(
+    test_ukf_node_interfaces
+    ukf_node)
+  ament_add_test(
+    test_ukf_node_interfaces
     GENERATE_RESULT_FOR_RETURN_CODE_ZERO
     TIMEOUT 300
-    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ukf_localization_node_interfaces.launch.py"
-  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-  )
+    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_se_node_interfaces.launch.py"
+    ENV NODE_TYPE=ukf
+  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
 
   #### DATA TESTS #####
 #  ament_add_gtest(test_ekf_localization_node_bag1 test/test_localization_node_bag_pose_tester.cpp)
@@ -292,9 +314,9 @@
     filter_base-test
     test_filter_base_diagnostics_timestamps
     test_ekf
-    test_ekf_localization_node_interfaces
+    test_ekf_node_interfaces
     test_ukf
-    test_ukf_localization_node_interfaces
+    test_ukf_node_interfaces
     #test_ekf_localization_node_bag1
     #test_ekf_localization_node_bag2
     #test_ekf_localization_node_bag3
@@ -330,6 +352,11 @@
   RUNTIME DESTINATION bin
 )
 
+install(DIRECTORY
+  include/
+  DESTINATION include/${PROJECT_NAME}
+  USE_SOURCE_PERMISSIONS)
+
 # Install params config files.
 install(DIRECTORY
   params
